const Plugin = {
    name: 'RemoveEntity',
    desc: '强制移除实体',
    ver: '1.0.0'
}
ll.registerPlugin(
    Plugin.name,
    Plugin.desc,
    Plugin.ver.split('.'), {
        author: '1503Dev'
    }
)
logger.setTitle(Plugin.name)

const Command = {
    init: ()=> {
        let cmd = mc.newCommand('rmentity', Plugin.desc, PermType.GameMasters)
        cmd.optional('entity', ParamType.Actor)
        cmd.overload(['entity'])
        cmd.setCallback((cmd, ori, outp, res) => {
            let entities = []
            if(res.entity) {
                entities = res.entity
            }
            if(ori.player){
                let pl = ori.player
                if(!res.entity) entities = [pl.getEntityFromViewVector(10)]
                if(entities == void 0 || entities.length == 0 || entities[0] == void 0){
                    outp.error('请选择一个实体')
                    return
                }
                let rez = ''
                entities.forEach(en=>{
                    let name = en.name
                    if(en.isPlayer()) {
                        outp.error('禁止移除玩家(' + name + ')')
                        return
                    }
                    try {
                        en.kill()
                        en.despawn()
                        en.remove()
                    } catch (e) {}
                    rez += ', ' + name
                })
                rez = rez.substring(2)
                outp.success('已移除 ' + rez)
                return
            } else {
                if(!res.entity) {
                    outp.error('请选择一个实体')
                    return
                }
                entities.forEach(en=>{
                    let name = en.name
                    if(en.isPlayer()) {
                        outp.error('禁止移除玩家(' + name + ')')
                        return
                    }
                    try {
                        en.kill()
                        en.despawn()
                        en.remove()
                    } catch (e) {}
                    rez += ', ' + name
                })
                rez = rez.substring(2)
                outp.success('已移除 ' + rez)
            }
        })
        cmd.setup()
    }
}

mc.listen('onServerStarted', () => {
    Command.init()
    log('加载完成')
    log('版本: ' + Plugin.ver + ' 由 1503Dev 制作')
})